#!/bin/bash

PORT=$1
THREADS=$2
ITER=$3


random_slash24()
{
	local tmpfile=`mktemp /tmp/scanXXXXXX`

	local oct1=$(($RANDOM%256))
	local oct2=$(($RANDOM%256))
	local oct3=$(($RANDOM%256))

	if ([ $oct1 -ge 224 ] || [ $oct1 -eq 10 ] || [ $oct1 -eq 172 ] || [ $oct1 -eq 192 -a $oct2 -eq 168 ] || [ $oct1 -eq 169 -a $oct2 -eq 254 ]) ; then
		echo "Skipping $oct1.$oct2.$oct3.0/24"
	else
		echo $oct1.$oct2.$oct3.0/24 | tee -a octets.list
		echo nmap -sV -p$PORT -PA$PORT --open -T4 -v $oct1.$oct2.$oct3.0/24
		nmap -sV -O -p$PORT -PA$PORT --script=banner --max-scan-delay=1.2s --open -T4 -v $oct1.$oct2.$oct3.0/24 >> $tmpfile
		cat $tmpfile >> ./result.scan
		rm -f $tmpfile >/dev/null 2>/dev/null
	fi
}

usage()
{
	echo -n "Usage:"
	echo " $0 <PORT> <THREADS> <NUM SUBNETS>"
	echo
	echo
}

###### MAIN
if [ -z $1 -o -z $2 ] ; then
	usage
	exit
fi

if [ ! -x "`which nmap`" ] ; then
        echo 'nmap was not found in $PATH'
        echo 'yum -y install nmap ; apt-get -y install nmap'
        exit
fi


i=0
until (( i > ITER )) ; do
	numnmap=`ps -ef | grep nmap | sed '/grep/d' | wc -l | awk '{print $1}'`
	if [ $numnmap -le $THREADS ] ; then
		random_slash24 &
		(( i++ ))
		sleep 0.3
	else
		sleep 10
	fi
done
