#!/bin/bash

PORT=$1
ITER=$2

#actually scans a random /16
random_slash24()
{
	local tmpfile=`mktemp /tmp/scanXXXXXX`

	local oct1=$(($RANDOM%256))
	local oct2=$(($RANDOM%256))
	#local oct3=$(($RANDOM%256))

	if ([ $oct1 -ge 224 ] || [ $oct1 -eq 10 ] || [ $oct1 -eq 172 ] || [ $oct1 -eq 192 -a $oct2 -eq 168 ] || [ $oct1 -eq 169 -a $oct2 -eq 254 ]) ; then
		echo "Skipping $oct1.$oct2.0.0/16"
	else
		echo $oct1.$oct2.0.0/16 | tee -a octets.list
		echo masscan -p$PORT --rate=2500 -oL - --range $oct1.$oct2.0.0/16
		masscan -p$PORT --rate=2500 -oL - --range $oct1.$oct2.0.0/16 >> $tmpfile
		cat $tmpfile >> ./result.scan
		rm -f $tmpfile >/dev/null 2>/dev/null
	fi
}

usage()
{
	echo -n "Usage:"
	echo " $0 <PORT> <NUM SUBNETS>"
	echo
	echo
}

###### MAIN
if [ -z $1 -o -z $2 ] ; then
	usage
	exit
fi

if [ ! -x "`which masscan`" ] ; then
	echo 'Masscan was not found in $PATH'
	echo 'https://github.com/robertdavidgraham/masscan'
	exit
fi

i=0
until (( i > ITER )) ; do
	random_slash24
	(( i++ ))
	sleep 0.3
done
